<?php
/**
 * An interface for local criterias
 *
 * @author		Roland Haeder <webmaster@ship-simu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007, 2008 Roland Haeder, 2009 - 2012 Core Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.ship-simu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
interface LocalSearchCriteria extends Criteria {
	/**
	 * Setter for limit
	 *
	 * @param	$limit	Search limit
	 * @return	void
	 * @todo	Find a nice casting here. (int) allows until and including 32766.
	 */
	function setLimit ($limit);

	/**
	 * "Setter" for limit from a configuration entry
	 *
	 * @param	$configEntry	The configuration entry which hold a number as limit
	 * @return	void
	 */
	function setConfiguredLimit ($configEntry);

	/**
	 * Getter for limit
	 *
	 * @return	$limit	Search limit
	 */
	function getLimit ();

	/**
	 * Setter for skip
	 *
	 * @param	$skip	Search skip
	 * @return	void
	 * @todo	Find a nice casting here. (int) allows until and including 32766.
	 */
	function setSkip ($skip);

	/**
	 * Getter for skip
	 *
	 * @return	$skip	Search skip
	 */
	function getSkip ();

	/**
	 * Checks whether the given key/value pair is matching with 'default' and one of 'choice' and
	 * never with in 'exclude'.
	 *
	 * @param	$key			Key element to check
	 * @param	$value			Value to check
	 * @return	$isMatching		Whether the key/value is matching or excluded
	 */
	function isCriteriaMatching ($key, $value);
}

// [EOF]
?>
